/**********************************************************************

	--- Dlgedit generated file ---

	File: ViewCd.cpp
	Last generated: Sat Nov 8 20:25:42 1997

 *********************************************************************/

#include "ViewCd.h"
#include <qdir.h>
#include <qmenubar.h>
#include <qfiledlg.h>
#include <qkeycode.h>
#include <qtstream.h>
#include <qfile.h>
#include <qfileinf.h> 
#include <qmsgbox.h> 
#include <qfontmet.h> 
#include <qapp.h>
#include <qprogdlg.h>
#include <qcursor.h>
#include <qregexp.h>
//#include "getdir.h"
#include "version.h"
#include <iostream.h>

extern int viewcd_windows; // should be a static member

// use these for both unix/WIN32, let Qt translate.  change for copy cmd
#define SLASH "/"
#define cSLASH '/'

#ifndef _WIN32
#include <stdlib.h>
#endif

#ifdef _WIN32
#include <process.h>
#endif

#define Inherited ViewCdData

ViewCd::ViewCd
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	QString start(".");
	
#ifdef DEBUG_WIN
	debug_win = new DebugWin;
	debug_win->show();
#endif        
	
	init(start);
}

ViewCd::ViewCd
(
	QString start
)
	:
	Inherited(NULL,NULL)
{
	init(start);
}

void ViewCd::init(QString start)
{

	setCaption( "View CD" );
	
	setFixedSize(width(),height());
	
	QPopupMenu *file_menu = new QPopupMenu();
	CHECK_PTR( file_menu);

	file_menu->insertItem("New", this, SLOT(new_window()), CTRL+Key_N);
	file_menu->insertItem("Open...", this, SLOT(open()), CTRL+Key_O);
	file_menu->insertItem("Refresh", this, SLOT(rescan()), CTRL+Key_R);
	file_menu->insertSeparator();
	file_menu->insertItem("Close", this, SLOT(close_win()), CTRL+Key_W);
	file_menu->insertSeparator();
	file_menu->insertItem("Quit", this, SLOT(exit()), CTRL+Key_Q);
	main_menu->insertItem("File", file_menu );
	
	edit_menu = new QPopupMenu();
	CHECK_PTR( edit_menu);

	edit_menu->insertItem("Copy", this, SLOT(copy_selected_files()), CTRL+Key_C);
	paste_item = edit_menu->insertItem("Paste", this, SLOT(paste()), CTRL+Key_V);
	edit_menu->insertSeparator();
	edit_menu->insertItem("Select All", this, SLOT(select_all()), CTRL+Key_A);
	edit_menu->insertItem("Invert Selection", this, SLOT(invert_select()), CTRL+Key_I);
	
	main_menu->insertItem("Edit", edit_menu );
	
	QPopupMenu *help_menu = new QPopupMenu();
	CHECK_PTR( help_menu);

	help_menu->insertItem("About...", this, SLOT(about()));
	
	main_menu->insertSeparator();
	main_menu->insertItem("Help", help_menu );
	
	have_trans = 0; /* not yet */
	
	current_dir = start.copy();
	
	rescan();	
	
	clip = QApplication::clipboard();
	
	QObject::connect(clip,SIGNAL(dataChanged()),this,SLOT(clip_changed()));
	
	//edit_menu->setItemEnabled(paste_item,FALSE);
	clip_changed(); // see if there is stuff of ours in the clipboard
			// enables paste if there is	
	
	files_list->setMultiSelection(TRUE);
	
        QObject::connect(this, SIGNAL(quit()),qApp, SLOT(quit()) );
        
        viewcd_windows++; // we have one more window open
        
        get_drives(); // fill drives_list on WIN32
        
	
}


ViewCd::~ViewCd()
{
}


void ViewCd::set_dir(QString dir)
{
QFile test;
int pos;

	current_dir = dir.copy();
	
	test.setName(current_dir);
	
	QFileInfo testinfo(test);
	
	if( testinfo.exists() && testinfo.isFile() ) // passed in a filename
	{	
		pos=current_dir.findRev(cSLASH,current_dir.length());
		if(pos > -1)
		{
			current_dir.truncate(pos+1); // leave the slash on 
		}
	}	

#ifdef DEBUG	
	out(current_dir);
#endif
	
	rescan();
	
	
}

void ViewCd::rescan()
{
QString file;
QStrList f_list,d_list,drv_list;

	QCursor org_cursor(cursor());
	
	QApplication::setOverrideCursor(waitCursor);

	QDir dirs(current_dir,0,QDir::Name,QDir::Dirs | QDir::Drives);
	
	if(!dirs.exists())
	{
		current_dir.setStr("."); // default to current
		dirs.setPath(current_dir);
	}
	
	current_dir = dirs.absPath(); // make sure current_dir is correct
	
	QDir files(current_dir,"*",QDir::Name,QDir::Files | QDir::NoSymLinks);
	
	read_trans(); // checks for TRANS.TBL and reads it in

	dirs_list->clear();
	
	d_list = *(dirs.entryList());
	
	translate(d_list);
	
	if( !drives_list.isEmpty() && dirs.isRoot() ) // we have drives and at root
	{
		int i,ins;
		ins = 0;
		if(strcmp(d_list.at(0),".") == 0 )
			ins = 1;
		if(strcmp(d_list.at(1),"..") == 0 )
			ins = 2;
		for(i=drives_list.count()-1;i>=0;i--)
		{
			if( !current_dir.contains(drives_list.at(i)))
				d_list.insert(ins, drives_list.at(i) ); // stick in at top of list
		}		
	}
	
	dirs_list->insertStrList(&d_list);
	
	files_list->clear();
	
	f_list = *(files.entryList());
	
	translate(f_list);
	
	files_list->insertStrList(&f_list);
	
	setCaption(current_dir);
	
	QApplication::setOverrideCursor(org_cursor);


}

void ViewCd::get_drives()
{
/*
	checks for the existance of drive letters 
	and fills drives_list
	with a list of them
*/

	drives_list.clear();

#ifdef _WIN32
QFile file;
char drv;
char filename[10];

	// skip the floppies
	strcpy(filename,"C:/");
	drv=filename[0];
	while( drv <= 'Z' ) // check all drives up to Z
	{
		file.setName(filename);
		if( file.exists() ) 
		{
#ifdef DEBUG
			QString stuff("Drive found: ");
			stuff.append(filename);
			out(stuff);
#endif		
			drives_list.append(filename);
		}
		drv++;
		filename[0]=drv;
	}
		
#endif

}

void ViewCd::read_trans()
{
/*
	reads in the file TRANS.TBL from the directory
	pointed to by current_dir
*/
QString filename,line,trans_tbl(TRANS_TBL),slash(SLASH);
QFile file;
	
	filename= current_dir + slash + trans_tbl;
	
	file.setName(filename);
	
	cd_names.clear();
	real_names.clear();
	
	have_trans = 0;
	
	if( ! file.exists() ) // lets try trans.tbl if no TRANS.TBL
	{
	
#ifdef DEBUG
		out (" no TRANS.TBL ");
#endif
		
		filename = current_dir + slash + trans_tbl.lower();
		file.setName(filename);
		
		if( !file.exists() ) // we don't have a trans.tbl
		{		
			return;
		}
#ifdef DEBUG		
		else
		{
			out ("files are mapped ");
		}
#endif
		
	}
		
	
	if( file.open(IO_ReadOnly) )
	{
		QTextStream ts(&file);
		
		while ( ! ts.eof() )
		{
		
			line = ts.readLine();
#ifdef DEBUG2			
			QString stuff("line: ");
			stuff.append(line);
			out(stuff);
#endif			
			parse_trans(line);
			
		}
		file.close();
		
		have_trans = 1;
			

	}
	
}

void ViewCd::parse_trans(QString line)
{
/*
	parses the lines in the TRANS.TBL file
	
	puts entries in the cd_names and real_names lists 
	if they are D or F type
	
*/
char cd_name[256],real_name[256];
uint p1,p2,p3;
QString cd_mapped;
	
	// check its a file or directory entry in TRANS.TBL
	
	if((line.left(1) == "D") || (line.left(1) == "F"))
	{
	
		p1 = line.find(' ');// find first blank
		p2 = line.find(' ',p1+1); // find next blank
		p3 = p2+1;
		while( (line.mid(p3+1,1) == " ") || (line.mid(p3+1,1) == "\t") ) // leaves p3 pointing to last blank
		{				// before real name
			p3++;
		}
	
		strcpy(cd_name,line.mid(p1+1,p2-p1-1));
		strcpy(real_name,line.mid(p3+1,line.length()-1));
		
		cd_names.append(cd_name);
		real_names.append(real_name);	
		
#ifdef DEBUG2
	QString stuff("cd: (");
	stuff.append(cd_name);
	stuff.append(") real :(");
	stuff.append(real_name);
	stuff.append(")");
	out(stuff);

#endif
		
	}

}

void ViewCd::translate(QStrList &list)
{
/*
	converts CD names to real names
	
	removes TRANS.TBL from list
	
	modifies the list in place
*/
unsigned int i,j;
int ttj;

	if(have_trans == 1)
	{
	    ttj = -1;
	    
	    for(j=0;j<list.count();j++)
	    {	    	
		for(i=0;i<cd_names.count();i++)
		{
			if(cmp_names(list.at(j),cd_names.at(i)) == 0) // ignore case
			{
#ifdef DEBUG2		
				QString stuff("replace: ");	
				stuff.append(list.at(j));
				stuff.append(" with ");
				stuff.append(real_names.at(i));
				out( stuff );
#endif				
				list.remove(j);
				list.insert(j,real_names.at(i));
				break;
			}
			if(stricmp(list.at(j),TRANS_TBL) == 0) // ignore case
			{
				ttj = j; // can't remove it here
			}
		}
	    }
	    if( ttj != -1)
	    	list.remove(ttj);// get rid of TRANS.TBL entry
	}


}

int ViewCd::cmp_names(QString name1,QString name2)
{
/*
	does a rockridge insensitive compare, that is,
	ignore case and ignore trailing version (;#)
	
	also ignores trailing '.''s
	
*/
int pos;

	pos = name1.find(';');
	if(pos > -1)
		name1.truncate(pos);
		
	pos = name1.find('.');
	if(pos > -1 && (pos == (name1.length()-1)) )
		name1.truncate(pos);
		
	pos = name2.find(';');
	if(pos > -1)
		name2.truncate(pos);
		
	pos = name2.find('.');
	if(pos > -1 && (pos == (name2.length()-1)) )
		name2.truncate(pos);
				
	return(stricmp(name1,name2));

}

void ViewCd::untranslate(QString &name)
/*
	converts a real name back to a cd name
	
	checks if file exists
	
	if not, checks cases with lowercase, no version and no trailing '.'
		
	returns an empty string if still not
	
*/
{
unsigned int i;
int pos,cnt;
QString test,cd_name;

	if(have_trans == 1)
	{
	
#ifdef DEBUG		
		QString info("untrans: ");
		info = info + name;	
		out (info);
#endif

		cd_name = name.copy();
		
		for(i=0;i<cd_names.count();i++)
		{
			if(cmp_names(name,real_names.at(i)) == 0)
			{
				
				cd_name.setStr(cd_names.at(i));				
				break;
			}
		}
		
		cnt = 0;
		
		QFile file;
		
		do // try until we find it
		{
			name = cd_name.copy();
			
			switch(cnt)
			{
				default: // when out of cases
					name.setStr("");
					return;
					
				case 0: // as in TRANS.TBL
					
					break;
					
				case 1: // with no version
					pos = name.find(';');
					if(pos > -1)
					{
						name.truncate(pos);
					}
			
					break;
					
				case 2: // with no version, lower case
					pos = name.find(';');
					if(pos > -1)
					{
						name.truncate(pos);
					}
					name = name.lower();
			
					break;
					
				case 3: // with no version, lower case, no period
					pos = name.find(';');
					if(pos > -1)
					{
						name.truncate(pos);
					}
					name = name.lower();
					pos = name.find('.');
					if(pos > -1 && (pos == (name.length()-1)) )
						name.truncate(pos);

					break;
					
				case 4: // with no version, no period
					pos = name.find(';');
					if(pos > -1)
					{
						name.truncate(pos);
					}
					pos = name.find('.');
					if(pos > -1 && (pos == (name.length()-1)) )
						name.truncate(pos);

					break;
					
				case 5: // lower case
					name = name.lower();
					
					break;
			}
			
			cnt++;
			
			test = current_dir.copy();
			test.append(SLASH);
			test.append(name); 
			
			file.setName(test);
		}
		while(!file.exists());
	
#ifdef DEBUG			
		out( name );
#endif
	}
	
}

void ViewCd::about()
{
	QString msg("ViewCd version ");
	QString ver(VERSION);
	QString by(" by T. Shield");

	msg=msg+ver+by;
	
#ifndef _WIN32
	QMessageBox::about( this, "About ViewCd",msg);
	
#else
	QMessageBox::message( "About", msg, "Dismiss" );
#endif

}

void ViewCd::exit()
{
	if(viewcd_windows > 1)
	{
#ifndef _WIN32

    		switch( QMessageBox::warning( this, "View CD","Close All Windows and Exit?",
                                  QMessageBox::Yes,
                                  QMessageBox::No | QMessageBox::Escape| QMessageBox::Default )) 
                { 
    				case QMessageBox::Yes:
      		  			break;
    				case QMessageBox::No: // NO
        				// abort
        				return;
        			default:
        				break;
    		} 
    			   			
#else

		if(! QMessageBox::query( "View CD", "Close All Windows and Exit?",  "Yes", "No" ))
                {
                     	return;                                          
                }

#endif        	        	        	        	
		
	}
	
	emit quit();
}

void ViewCd::open()
{
//QFileDialog fd(current_dir,0, this,"Select Directory", TRUE );
//GetDirDialog fd(current_dir,0, this,"Select Directory", TRUE );



	//fd.exec(); // ignores whether accept or cancel clicked

	//current_dir.setStr(fd.dirPath());
	
	QString dir(QFileDialog::getOpenFileName(current_dir));
	
	if( !dir.isNull())		
	{
		QRegExp rx("\\"); // backslash
		
		dir.replace(rx,"/");
		
		//out(dir);
		
		set_dir(dir);
	}
 

}

void ViewCd::new_window() // open a new window
{
	ViewCd *vcd;
	
	vcd = new ViewCd(current_dir);
	
	vcd->show();

}

void ViewCd::close_win() // close just this window if more than one are open
{
	if(viewcd_windows > 1)
	{
		viewcd_windows--;
		done(0);
	}
	else
		emit quit();
}

void ViewCd::dir_selected(int index) // slot for double click on directory
				// changes to new directory
{	
QString new_dir;
int is_drive,i;

	is_drive = 0;

	new_dir = dirs_list->text(index);
	
	if( !drives_list.isEmpty() ) // check if its a drive spec
	{
		for(i=0;i<drives_list.count();i++)
		{
			if( new_dir == drives_list.at(i))
			{
				is_drive = 1;
				break;
			}
		}
	}


	
	if( new_dir != ".." && new_dir != "." && is_drive == 0)
		untranslate(new_dir);	
		
	if(!new_dir.isEmpty() && is_drive == 0)	
	{
		current_dir.append(SLASH);
		current_dir.append(new_dir);

		rescan();
	}
	
	if( is_drive == 1 )
	{
		current_dir = new_dir.copy();
		rescan();
	}

}

void ViewCd::file_selected(int index) // slot for double click on file -- show file info
{
QString file,cdfile,absfile,slash(SLASH);
char info[200],sfile[100],mod[100];
uint fs;

	file.setStr(files_list->text(index));
	
	cdfile=file.copy();
	
	untranslate(cdfile); // convert to real name
	
	if(cdfile.isEmpty()) // file does not exist -- should never happen
	{
		qApp->beep();
		return;
	}
	
	absfile = current_dir + slash + cdfile;
	
	QFileInfo fi(absfile);
	
	fs = fi.size();
	
	strcpy(sfile,file);
	strcpy(mod,fi.lastModified().toString());
	
	sprintf(info,"%s: %i bytes, last modified on %s",sfile,fs,mod);

#ifndef _WIN32
    			QMessageBox::warning( this, "View CD",info,
                                  QMessageBox::Ok| QMessageBox::Escape| QMessageBox::Default,0 );
#else
			QMessageBox::message( "View CD", info, "Dismiss" );

#endif
	

}

void ViewCd::copy_selected_files() // slot for edit menu copy
{
uint i,num_sel;
QString sel_files,file,abs_file,slash(SLASH);

	sel_files.append(CLIP_MAGIC); // magic for clipboard
	
	num_sel = 0;

	for(i=0;i<files_list->count();i++)
	{
		if(files_list->isSelected(i) == TRUE)
		{
			file.setStr(files_list->text(i)); // gets real name from list
			
			untranslate(file); // convert back to cd name
			
			if(!file.isEmpty()) // file does not exist, should not happen
			{
				abs_file = current_dir+slash+file; // abs name of cd file
				sel_files.append(abs_file);// abs name on cd 
				sel_files.append("\t");// tab separator
				sel_files.append(files_list->text(i));// real name no path (yet)
				sel_files.append("\n");
				num_sel++;
			}
		}
	}

#ifdef DEBUG			
	out(sel_files);
#endif
	
	if(num_sel > 0)
	{
		clip->clear();
		clip->setText(sel_files);
	}
	else
	{
		qApp->beep(); // nothing is selected
	}
	
}

void ViewCd::select_all()
{
uint i;

	if(files_list->currentItem() == -1)
	{
		files_list->setCurrentItem(0);
	}

	for(i=0;i<files_list->count();i++)
	{
		files_list->setSelected(i,TRUE);
	}

}

void ViewCd::invert_select()
{
uint i;

	if(files_list->currentItem() == -1)
	{
		files_list->setCurrentItem(0);
	}

	for(i=0;i<files_list->count();i++)
	{
		if(files_list->isSelected(i) == FALSE)
			files_list->setSelected(i,TRUE);
		else
			files_list->setSelected(i,FALSE);
	}

}

void ViewCd::clip_changed() // slot for clipboard change events
{
	edit_menu->setItemEnabled(paste_item,FALSE);
		
	if(clip->text() == NULL) // empty clip board
	{
		return;
	}
		
	if(strstr(clip->text(),CLIP_MAGIC) != NULL ) // our stuff
	{
		edit_menu->setItemEnabled(paste_item,TRUE);
	}

}

void ViewCd::paste() // copies files to current directory
{
QString sel_files,from,to,slash(SLASH),msg("Copy files to "),dquote("\"");
char cmd[600];
uint pos,p1,p2;
int rc;

	sel_files.setStr(clip->text());
	
	if(sel_files.contains(CLIP_MAGIC) == 0) // not our stuff
	{
		qApp->beep();
		return;		
	}

	pos = strlen(CLIP_MAGIC);
	
	msg.append(current_dir);
	
#ifndef _WIN32

    		switch( QMessageBox::warning( this, "View CD",msg,
                                  QMessageBox::Yes,
                                  QMessageBox::No | QMessageBox::Escape| QMessageBox::Default )) 
                { 
    				case QMessageBox::Yes:
      		  			break;
    				case QMessageBox::No: // NO
        				// abort
        				return;
        			default:
        				break;
    		} 
    			   			
#else

		if(! QMessageBox::query( "View CD", msg,  "Yes", "No" ))
                {
                     	return;                                          
                }

#endif        	        	        	        	

	int numfiles,file;

	numfiles = sel_files.contains('\t');

	QProgressDialog progress( "Copying files...", "Abort Copy", numfiles, this,"View Cd",TRUE );

	file = 0;
 	
	while( pos < sel_files.length() )
	{
	
		progress.setProgress( file );
		if( progress.wasCancelled() )
                {
                    	break;
                } 
                   
		p1 = sel_files.find('\t',pos); // find separator tab
		from = sel_files.mid(pos,p1-pos);
		p2 = sel_files.find('\n',p1); // find end newline
		to = sel_files.mid(p1+1,p2-p1-1);
		to = current_dir + slash + to;
		
#ifdef _WIN32		
		strcpy(cmd,"copy ");
#else
		strcpy(cmd,"cp ");
#endif

// double qoute the filenames to allow spaces and ';' and other
// special characters in filenames

		from = dquote+from+dquote;
		to = dquote+to+dquote;
		
		strcat(cmd,from);
		strcat(cmd," ");
		strcat(cmd,to);
		
#ifdef _WIN32
/* 
	need to change all '/' to '\' for WIN32
*/
int i;
	for(i=0;i<strlen(cmd);i++)
	{
		if( cmd[i] == '/')
		{
			cmd[i] = '\\';
		}	
	}

#endif		
		
#ifdef DEBUG			
		out( cmd );
#endif
		
		rc = system(cmd); // do it
		if( rc != 0 )
		{
			progress.reset();
			
			QString err_msg("Error occurred during copy");
#ifndef _WIN32
    			QMessageBox::warning( this, "View CD",err_msg,
                                  QMessageBox::Ok| QMessageBox::Escape| QMessageBox::Default,0 );
#else
			QMessageBox::message( "View CD", err_msg, "Dismiss" );

#endif
		
			break;
		}
		
		pos = p2+1; // start of next one after newline
		file ++;
	}
	
	progress.setProgress( numfiles );
	
	rescan();
}

void ViewCd::out(QString info)
{

#ifdef DEBUG
#ifdef DEBUG_WIN
	if(debug_win->isVisible())
		debug_win->perror(info);
#else
	cout << info << "\n";
#endif
#endif

}
